#ifndef AFX_ISHTOOL_H__7104A281_4501_11D4_8D96_B7EEA0A4E334__INCLUDED_
#define AFX_ISHTOOL_H__7104A281_4501_11D4_8D96_B7EEA0A4E334__INCLUDED_

#include "Tool.h"

class CIshTool : public CTool
{
//
// original source is
//
// ish fot unix 2.01a5 ( 1993.09.25 )
//   http://www.vector.co.jp/soft/unix/util/se004518.html
//

public:
	CIshTool() : CTool( "Ish Decode" ){}

	bool IsType( const char* ext )
		{return 0==stricmp(ext,"ish");}

	bool Check( const char* fname, unsigned long fsize );
	bool Extract( const char* fname, const char* ddir );

private:
	FILE *ish;
	char IshName[MAX_PATH];

	bool FindHeader(bool bfirst=true);
	bool ProcessHeader(BYTE* dat,int l,bool bfirst);
	int  GetBlockData();
	bool GetNextVol();

	// PubNp̃f[^
	BYTE block[100][100];
	int  blocklen[100];
	BYTE checker[100];
	BYTE checker2[100];
	int ErrCt,ErrLine[2];

	char h_LFN[MAX_PATH];
					// 1    K0
	BYTE h_Mv;		// 2    0:single vol format , 1-250:number of mv format files , 251-reserved
	DWORD h_FLen;	// 3- 6 Ƃ̃t@C̒(LE)
	WORD h_LLen;	// 7- 8 s̒(69/63/73/69)
	WORD h_LNum;	// 9-10 ubN̍s(68/62/72/68)
	BYTE h_MType;	// 11   ̧ق̕HH(8:jis8, 16:jis7 or shift jis or shift jis(non-kana))
	BYTE h_IType;	// 12   isḩق̕(8:jis8, 13:jis7, 14: shift jis(non-kana), 15:shift jis)
	char h_FName[12];// 13-23 ̧ٖ
					// 24   ̧ق̎(ެ)(0:gp)
					// 25   ΏOS
	bool h_bOld;	// 26   ish file̊g߁iQ޲Ėڂ̕⑫pj
					//      (Q޲Ėڂ0̎ -> 0:ols_sytle, 1:2s)
	BYTE h_Flag;	// 27 0ޯ -> 1:time stamp is available, 0:not available
					//    1ޯ -> 1:difference of time is available, 0:not avail.
					//    2ޯ -> 1:CRC-16(file) is available, 0:not avail.
					//    3ޯ -> 1:CRC-32(file) is available, 0:not avail.
					//    4ޯ -> 1:CRC-16(volume) is available, 0:not avail.
	DWORD h_LcTime;	//28-31
	DWORD h_DifTm;	//32-34  tRoCgB(b)
	WORD  h_FCRC16;	//35-36  fileŜCRC-16
	DWORD h_FCRC32;	//37-40  fileŜCRC-32
	DWORD h_VLen;	//41-44  evolumeɊ܂܂Byte(single volume format̎0)
	WORD  h_VCRC16;	//45-46  volumeCRC-16(single volume format̎0)
					//47-61 (0)(ͯނjis8 formatō쐬ꍇɂ́A47`67޲Ė)
	WORD  h_CRC;	//62-63 P`67(61/67/61)޲Ėڂ܂łCRC
					//       (ͯނjis8 formatō쐬ꍇɂ́A68`69޲Ė)
};

#endif
